/* 
 An application for computing the maximum computable factorial on the current C platform.
 */

#include <stdio.h>
#include <limits.h>

int maxInteger = INT_MAX;
typedef enum{false,true} bool;

int fact(int n){/* undefined when n<0: n!, otherwise */
	if (n == 0) return 1;
	return n * fact(n-1);
}

int main (int argc, char *argv[]){
    int num = 1; //initial candidate for the expected number
    bool test = true;
    int factNum = 1;
    while (test) {
        factNum = fact(num++);
        test = (maxInteger/factNum) >= num;
    }
    printf("The maximum signed integer is %d. Then:\n",maxInteger);
    printf("       the maximum computable factorial is %2d!=%d\n",num-1,factNum);
}
