#include <stdio.h>
#include <stdlib.h>
#include <time.h>
int k = 100; /* parametro di programma ... */
int fact(int n){/* diverge quando n<0, altrimenti n! */
	if (n==0) return 1;
	return n * fact(n-1);
}
int memoizedFact(int n){/* diverge quando n<0, altrimenti n! */
						/* definizione memoized */
	static int Tab[100];
	static int index=0;
	Tab[0]=1;
	if ((n<=index)&!(n<0)) return Tab[n];
	Tab[n] = n * memoizedFact(n-1);
	return Tab[index=n];
}
int main (int argc, char *argv[]){
	int x = 5;
    clock_t Finit,Fend;
    double time;
    {//running fact
        Finit = clock();//lettura clock prima
        fact(x)+fact(x+1);//-- espressione usata come comando
        Fend = clock();//lettura clock dopo
        time = (double)Fend-Finit; //tempo impiegato misurato in mu-seconds
        printf("fact(%1d)+fact(%1d+1) impiega %-2.2f mu-s\n",x,x,(double)Fend-Finit);
    }
    {//running fact
        Finit = clock();
        memoizedFact(x)+memoizedFact(x+1);
        Fend = clock();
        printf("memoizedfact(%1d)+memoizedfact(%1d+1) impiega %-2.2f mu-s\n",x,x,(double)Fend-Finit);
    }
}
